/**************************************************************************
 *
 *   Program          :  main.cpp
 *   Purpose          :  matrix vector multiplication using MPI.
 *   Programmer       :  Umesh S. Shisode
 *   Created on       :  14-01-2015
 *   Last Modified    :  Wednesday 20 May 2015 03:20:27 PM IST
 *
 **************************************************************************/
#include"vect_fun.h"
#include<mpi.h>

int main(int argc, char *argv[])
{
	Vector<double> b;
	int rank, nproc, local_row, uLim, lLim, Ncol, Nrow, count, A_row;
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &nproc);
	MPI_Status status;
	MPI_Request request;

//------------------------------------------------------------INPUT-----------------------------------------------------------------------------------
	if (rank == 0){
		b.read("Input/Vector1.txt");
//------------------------------------------------------------PRINT----------------------------------------------------------------------------------
		cout << "Vector b before broadcast: at rank " << rank << "\n";
		b.print();
	}

	MPI_Bcast((double*)b.vect, Ncol, MPI_DOUBLE, 0, MPI_COMM_WORLD);

	if (rank > 0){
//		b.read("Input/Vector1.txt");
		cout << "After Broadcasting b is : \n" << b.get(0) << endl;
		b.print();
	}

	if (rank == 0){
		cout << endl;
	}

//------------------------------------------------------------SOLVE----------------------------------------------------------------------------

	MPI_Finalize();
	return 0;
}
